﻿//########################
//InDesignCS4で名刺をドキュメントに配置し
//名刺カッター「きりっ子miniSK-202S」用に配置しトンボを付けて保存します。
//たけうちとおる
//########################
var x_offset = 0;//x方向へ微調整するにはこの値を変更
var y_offset = 0;//y方向へ微調整するにはこの値を変更
var meishiW = 91;
var meishiH = 55;
var startX = 9;
var startY = 11;
//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();

function main(){
	var selFile = File.openDialog("名刺ファイルを選択してください（複数選択可）","",true);
	if(selFile == null){
		return;
	}
	var myDocu = app.documents.add();
	myDocu.documentPreferences.pageWidth = "210mm";
	myDocu.documentPreferences.pageHeight = "297mm";
	myDocu.documentPreferences.pagesPerDocument = 1;
	myDocu.documentPreferences.facingPages  = false;
	
	var selfilecount = selFile.length;
	var fsname = selFile[0].fsName + ".indd";
	var fileObj = new File(fsname);
	for(var f = 0;f < selfilecount;f++){
		if(f > 0){
			myDocu.pages.add();
		}
		drowRect(myDocu.pages[f],102,11,6,6)
		drowRect(myDocu.pages[f],102,280,6,6)
		for(var y = 0;y < 5;y++){
			var y1 = startY + meishiH * y;
			var y2 = y1 + meishiH;
			for(var x = 0;x < 2;x++){
				var x1 = startX + (meishiW + 10) * x;
				var x2 =x1 + meishiW;
				place_meishi(myDocu.pages[f],selFile[f],x1,x2,y1,y2);
				if(y == 0){
					//上の罫線
					drowLine(myDocu.pages[f],x1,x1,y1-13,y1-3);
					drowLine(myDocu.pages[f],x2,x2,y1-13,y1-3);
					//横の罫線
					if(x == 0){
						drowLine(myDocu.pages[f],x1-13,x1-3,y1,y1);
					}else{
						drowLine(myDocu.pages[f],x2+13,x2+3,y1,y1);
					}
				}else if(y == 4){
					//下の罫線
					drowLine(myDocu.pages[f],x1,x1,y2+13,y2+3);
					drowLine(myDocu.pages[f],x2,x2,y2+13,y2+3);
				}
				//横の罫線
				if(x == 0){
					drowLine(myDocu.pages[f],x1-13,x1-3,y2,y2);
				}else{
					drowLine(myDocu.pages[f],x2+13,x2+3,y2,y2);
				}
			}
		}
	}
	myDocu.save(fileObj);
}

function place_meishi(pageObj,selFile,x1,x2,y1,y2){
	var rectObj = pageObj.rectangles.add();
	rectObj.strokeWeight = 0;
	var rectbounds = new Array(y1+y_offset,x1+x_offset,y2+y_offset,x2+x_offset);
	rectObj.geometricBounds = rectbounds;
	var meishiobj = rectObj.place(selFile);
	var meishiB = rectObj.allGraphics[0].geometricBounds;
	if((meishiB[2] - meishiB[0]) > (meishiB[3] - meishiB[1])){
		//縦長
		rectObj.allGraphics[0].rotationAngle = 90;
	}
	rectObj.fit (FitOptions.CENTER_CONTENT);
}

function drowLine(pageObj,X1,X2,Y1,Y2){
	myLine=app.activeWindow.activeSpread.rectangles.add();
	myLine.paths.item(0).entirePath=[[X1+x_offset,Y1+y_offset],[X2+x_offset,Y2+y_offset]];
	myLine.strokeWeight=0.05;
	var myRegistrationColor = app.activeDocument.colors.item("Registration");
	myLine.strokeColor=myRegistrationColor;
	return myLine;
}

function drowRect(pageObj,X,Y,W,H){
	myObj = pageObj.rectangles.add();
	myObj.geometricBounds = [Y+y_offset,X+x_offset,Y+H+y_offset,X+W+x_offset];
	myObj.strokeWeight=0;
	var myRegistrationColor = app.activeDocument.colors.item("Registration");
	myObj.fillColor=myRegistrationColor;
}